// Generated by CoffeeScript 2.2.1
(function() {
  // Represents an attribute
  var XMLAttribute;

  module.exports = XMLAttribute = class XMLAttribute {
    // Initializes a new instance of `XMLAttribute`

    // `parent` the parent node
    // `name` attribute target
    // `value` attribute value
    constructor(parent, name, value) {
      this.options = parent.options;
      this.stringify = parent.stringify;
      if (name == null) {
        throw new Error("Missing attribute name of element " + parent.name);
      }
      if (value == null) {
        throw new Error("Missing attribute value for attribute " + name + " of element " + parent.name);
      }
      this.name = this.stringify.attName(name);
      this.value = this.stringify.attValue(value);
    }

    // Creates and returns a deep clone of `this`
    clone() {
      return Object.create(this);
    }

    // Converts the XML fragment to string

    // `options.pretty` pretty prints the result
    // `options.indent` indentation for pretty print
    // `options.offset` how many indentations to add to every line for pretty print
    // `options.newline` newline sequence for pretty print
    toString(options) {
      return this.options.writer.set(options).attribute(this);
    }

  };

}).call(this);
