// Generated by CoffeeScript 2.2.1
(function() {
  var XMLDTDNotation, XMLNode;

  XMLNode = require('./XMLNode');

  // Represents a NOTATION entry in the DTD
  module.exports = XMLDTDNotation = class XMLDTDNotation extends XMLNode {
    // Initializes a new instance of `XMLDTDNotation`

    // `parent` the parent `XMLDocType` element
    // `name` the name of the notation
    // `value` an object with external entity details
    // `value.pubID` public identifier
    // `value.sysID` system identifier
    constructor(parent, name, value) {
      super(parent);
      if (name == null) {
        throw new Error("Missing notation name");
      }
      if (!value.pubID && !value.sysID) {
        throw new Error("Public or system identifiers are required for an external entity");
      }
      this.name = this.stringify.eleName(name);
      if (value.pubID != null) {
        this.pubID = this.stringify.dtdPubID(value.pubID);
      }
      if (value.sysID != null) {
        this.sysID = this.stringify.dtdSysID(value.sysID);
      }
    }

    // Converts the XML fragment to string

    // `options.pretty` pretty prints the result
    // `options.indent` indentation for pretty print
    // `options.offset` how many indentations to add to every line for pretty print
    // `options.newline` newline sequence for pretty print
    toString(options) {
      return this.options.writer.set(options).dtdNotation(this);
    }

  };

}).call(this);
